# 【Level3-1】

## テーマ
DDL, DMLが作成できるようになろう

## 演習課題の準備（開発環境について）
* この演習では、Codespacesと呼ばれるサービスを使って開発を行います。
* ブラウザ上で動作する開発環境です、インストール不要で使う事ができます。
* レベル0で実施した[手順](/Codespacesの実行手順.md)を参照して、演習課題の準備をしましょう。

## 演習内容
lessonを参考にDBに実績テーブルを追加しましょう。
初期データを投入するINSERT文も作成して下さい。

## 演習内容詳細
実績テーブルは以下の仕様で作成してください。  

**テーブル名:ARCHIEVEMENT**
|列名|データ型|制約・属性|備考|
|---|---|---|---|
|id|INT|NOT NULL AUTO_INCREMENT|このテーブルの主キーとなる項目|
|name|VARCHAR(100)|NOT NULL|実績名|
|memo|VARCHAR(100)|NOT NULL|メモ|

id列は主キーとするためPRIMARY KEY制約も付与してください。

* 初期データとして以下のレコードを投入するINSERT文を作成してください。 

|name|memo|
|---|---|
|ITパスポート||
|基本情報||
|portal作成|http://github.com|

## ヒント解説
起動の度に、以下2つのファイル内のSQL文が実行されます。
* `~\portal\src\main\resources\schema.sql`
* `~\portal\src\main\resources\data.sql`  

`schema.sql`には、CREATE TABLE文などのDDL[^1]を、`data.sql`には、INSERT文などのDML文[^2]を記載します。
テーブル定義を変えたい、初期データに何か手を加えたい時は上記2ファイルを変更してください。
以下の構文を参考に、それぞれのファイルにCREATE TABLE文と、INSERT文を追記してください。  
[^1]: データベースにおいて、データ構造の定義に用いられるSQL。  
[^2]: データベースにおいて、データの検索・新規登録・更新・削除を行うためのSQL。



## CREATE TABLE文の構文
CREATE TABLE文はデータベースにテーブルを作成するSQL文です。  
今回の演習ではCREATE TABLE文を作成するため、参考に構文を記載します。  
```
CREATE TABLE テーブル名
(
   列名1 データ型 制約・属性 ,
   列名2 データ型 制約・属性 ,
   PRIMARY KEY(主キー制約を付与する列名)
);
```
## INSERT文の構文
INSERT文はテーブルにデータを追加するSQL文です。
```
INSERT INTO テーブル名 (列名1, 列名2) VALUES (値1, 値2);
```
AUTO_INCREMENT属性が設定されている列への値の指定は不要です、列名自体記載しないか、NULL値を入れるようにしてください。  
NOT NULLの制約が設定されている列へは、NULL値が格納出来ないため、空文字`''`を格納してください。

### データ型について
テーブルのデータ型について解説します。
|データ型|説明|
|---|---|
|VARCHAR(n)|文字列を格納するデータ型です、カッコ内には格納する文字列の最大桁数を記載してください。|
|INT|-2,147,483,647から2,147,483,647の範囲の整数値を格納するデータ型です。|
|BOOLEAN|true,falseの真偽値を格納するデータ型です。|

### 制約・属性について
テーブルの制約・属性について解説します。
|制約・属性|説明|
|---|---|
|NOT NULL|NULL値が入れられなくなる制約です、必須項目にしたい項目に指定します。|
|AUTO_INCREMENT|自動で連番を格納する属性です、属性が設定された列に格納されている値+1の値を自動的に格納します。|
|PRIMARY KEY|主キー制約です、主キー列に指定します。主キー列とは、テーブル内の行を一意に識別する事の出来る列の事です。この制約を付与する事で重複する値を格納出来なくなります。|

## 課題の提出
* 課題の提出は[課題提出の操作](/課題の提出手順.md)のコミット・プッシュ・プルリクエストを実施しましょう。

